# mypy-boto3-sdb

[![PyPI - mypy-boto3-sdb](https://img.shields.io/pypi/v/mypy-boto3-sdb.svg?color=blue)](https://pypi.org/project/mypy-boto3-sdb)
[![PyPI - Python Version](https://img.shields.io/pypi/pyversions/mypy-boto3-sdb.svg?color=blue)](https://pypi.org/project/mypy-boto3-sdb)
[![Docs](https://img.shields.io/readthedocs/mypy-boto3-builder.svg?color=blue)](https://mypy-boto3-builder.readthedocs.io/)
[![PyPI - Downloads](https://img.shields.io/pypi/dw/mypy-boto3-sdb?color=blue)](https://pypistats.org/packages/mypy-boto3-sdb)

![boto3.typed](https://github.com/vemel/mypy_boto3_builder/raw/master/logo.png)

Type annotations for
[boto3.SimpleDB 1.17.65](https://boto3.amazonaws.com/v1/documentation/api/1.17.65/reference/services/sdb.html#SimpleDB)
service compatible with [VSCode](https://code.visualstudio.com/),
[PyCharm](https://www.jetbrains.com/pycharm/),
[Emacs](https://www.gnu.org/software/emacs/),
[Sublime Text](https://www.sublimetext.com/),
[mypy](https://github.com/python/mypy),
[pyright](https://github.com/microsoft/pyright) and other tools.

Generated by
[mypy-boto3-buider 4.10.0](https://github.com/vemel/mypy_boto3_builder).

More information can be found on
[boto3-stubs](https://pypi.org/project/boto3-stubs/) page and in
[mypy-boto3-sdb docs](https://github.com/vemel/mypy_boto3_builder/service_docs/mypy_boto3_sdb/README.md)

See how it helps to find and fix potential bugs:

![boto3-stubs demo](https://github.com/vemel/mypy_boto3_builder/raw/master/demo.gif)

- [mypy-boto3-sdb](#mypy-boto3-sdb)
  - [How to install](#how-to-install)
  - [Usage](#usage)
    - [VSCode](#vscode)
    - [PyCharm](#pycharm)
    - [Other IDEs](#other-ides)
    - [mypy](#mypy)
    - [pyright](#pyright)
  - [Explicit type annotations](#explicit-type-annotations)
    - [Client annotations](#client-annotations)
    - [Paginators annotations](#paginators-annotations)
    - [Literals](#literals)
    - [Typed dictionaries](#typed-dictionaries)

## How to install

Install `boto3-stubs` for `SimpleDB` service.

```bash
python -m pip install boto3-stubs[sdb]
```

## Usage

### VSCode

- Install
  [Python extension](https://marketplace.visualstudio.com/items?itemName=ms-python.python)
- Install
  [Pylance extension](https://marketplace.visualstudio.com/items?itemName=ms-python.vscode-pylance)
- Set `Pylance` as your Python Language Server
- Install `boto-stubs[sdb]` in your environment:
  `python -m pip install 'boto3-stubs[sdb]'`

Both type checking and auto-complete should work for `SimpleDB` service. No
explicit type annotations required, write your `boto3` code as usual.

### PyCharm

- Install `boto-stubs[sdb]` in your environment:
  `python -m pip install 'boto3-stubs[sdb]'`

Both type checking and auto-complete should work for `SimpleDB` service. No
explicit type annotations required, write your `boto3` code as usual.
Auto-complete can be slow on big projects or if you have a lot of installed
`boto3-stubs` submodules.

### Other IDEs

Not tested, but as long as your IDE support `mypy` or `pyright`, everything
should work.

### mypy

- Install `mypy`: `python -m pip install mypy`
- Install `boto-stubs[sdb]` in your environment:
  `python -m pip install 'boto3-stubs[sdb]'`
- Run `mypy` as usual

Type checking should work for `SimpleDB` service. No explicit type annotations
required, write your `boto3` code as usual.

### pyright

- Install `pyright`: `yarn global add pyright`
- Install `boto-stubs[sdb]` in your environment:
  `python -m pip install 'boto3-stubs[sdb]'`
- Optionally, you can install `boto3-stubs` to `typings` folder.

Type checking should work for `SimpleDB` service. No explicit type annotations
required, write your `boto3` code as usual.

## Explicit type annotations

### Client annotations

`SimpleDBClient` provides annotations for `boto3.client("sdb")`.

```python
import boto3

from mypy_boto3_sdb import SimpleDBClient

client: SimpleDBClient = boto3.client("sdb")

# now client usage is checked by mypy and IDE should provide code auto-complete

# works for session as well
session = boto3.session.Session(region="us-west-1")
session_client: SimpleDBClient = session.client("sdb")
```

### Paginators annotations

`mypy_boto3_sdb.paginator` module contains type annotations for all paginators.

```python
from mypy_boto3_sdb import SimpleDBClient
from mypy_boto3_sdb.paginator import (
    ListDomainsPaginator,
    SelectPaginator,
)

client: SimpleDBClient = boto3.client("sdb")

# Explicit type annotations are optional here
# Type should be correctly discovered by mypy and IDEs
# VSCode requires explicit type annotations
list_domains_paginator: ListDomainsPaginator = client.get_paginator("list_domains")
select_paginator: SelectPaginator = client.get_paginator("select")
```

### Literals

`mypy_boto3_sdb.literals` module contains literals extracted from shapes that
can be used in user code for type checking.

```python
from mypy_boto3_sdb.literals import (
    ListDomainsPaginatorName,
    SelectPaginatorName,
)

def check_value(value: ListDomainsPaginatorName) -> bool:
    ...
```

### Typed dictionaries

`mypy_boto3_sdb.type_defs` module contains structures and shapes assembled to
typed dictionaries for additional type checking.

```python
from mypy_boto3_sdb.type_defs import (
    AttributeTypeDef,
    DeletableItemTypeDef,
    DomainMetadataResultTypeDef,
    GetAttributesResultTypeDef,
    ItemTypeDef,
    ListDomainsResultTypeDef,
    PaginatorConfigTypeDef,
    ReplaceableAttributeTypeDef,
    ReplaceableItemTypeDef,
    SelectResultTypeDef,
    UpdateConditionTypeDef,
)

def get_structure() -> AttributeTypeDef:
    return {
      ...
    }
```
